;===========================================================================================
; Menu_1.asm  Fasm Flat assembler
; Menu
; Programm par AsmGges France
;===========================================================================================

format PE GUI 4.0
entry start

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  include 'win32a.inc'
  include 'macro\if.inc'

;===========================================================================================
; Dbut du code programme
; -----------------------
section '.code' code readable executable

start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Chargement d'une icne
    ; ----------------------
    invoke LoadIcon,[wc.hInstance],IDI_FRANCE
    mov [wc.hIcon],eax

    ; Chargement d'un curseur
    ; -----------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    ; Chargement d'un menu
    ; --------------------
    invoke LoadMenu,[wc.hInstance],IDM_MENU
    mov [hMenu],eax

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Obtenir la hauteur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CYSCREEN
    sub eax,[WinH]
    shr eax,1
    mov [WinY],eax

    ; Valider le choix de la structure WNDCLASS
    ; -----------------------------------------
    invoke RegisterClass,wc

    ; Cration de la fentre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,WS_EX_CLIENTEDGE,ClassName,Title,WS_OVERLAPPEDWINDOW+WS_VISIBLE,\
                          [WinX],[WinY],[WinW],[WinH],0,[hMenu],[wc.hInstance],0
    mov [hWnd],eax

    ; Affichage de la fentre
    ; -----------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT

    ; Rafraichissement de la fentre
    ; ------------------------------
    invoke UpdateWindow,[hWnd]

 ;----------------------------------
 ; Boucle de traitement des messages
 ;----------------------------------
 MessageLoop:
    ; Rceptionne les messages
    ; ------------------------
    invoke GetMessage,msg,0,0,0
    or eax,eax
    jz ExitProgram

    ; Traduit les touches d'entre clavier en messages
    ; ------------------------------------------------
    invoke TranslateMessage,msg

    ; Expdition des messages  la procdure Windows
    ; ---------------------------------------------
    invoke DispatchMessage,msg

    jmp MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
proc WindowProc uses ebx esi edi, @hWnd, @uMsg, @wParam, @lParam

    .if [@uMsg] = WM_CLOSE
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hWnd],MsgEnd,ClassName,MB_OK+MB_ICONINFORMATION

        ; Demande la fin de l'application
        ; -------------------------------
        invoke PostQuitMessage,0

    .elseif [@uMsg] = WM_COMMAND
        mov  eax,[@wParam]
        .if eax = IDM_BONJOUR
            ; Boite  message sous menu 1_1
            ; -----------------------------
            invoke MessageBox,[@hWnd],MsgBoxSM1_1,ClassName,MB_OK

        .elseif eax = IDM_AUREVOIR
            ; Boite  message sous menu 1_2
            ; -----------------------------
            invoke MessageBox,[@hWnd],MsgBoxSM1_2,ClassName,MB_OK

        .elseif eax = IDM_QUITTER
            ; Boite  message sous menu 1_2
            ; -----------------------------
            invoke MessageBox,[@hWnd],MsgBoxSM1_3,ClassName,MB_OK+MB_ICONEXCLAMATION

            ; Demande la fin de l'application
            ; -------------------------------
            invoke PostQuitMessage,0

        .elseif eax = IDM_SMENU21
            ; Boite  message sous menu 2_1
            ; -----------------------------
            invoke MessageBox,[@hWnd],MsgBoxSM2_1,ClassName,MB_OK

        .elseif eax = IDM_MENU3
            ; Boite  message menu 3
            ; ----------------------
            invoke MessageBox,[@hWnd],MsgBoxM3,ClassName,MB_OK+MB_ICONINFORMATION

        .endif

    .else
        ; Traitement par dfaut des autres messages Windows
        ; ------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret

    .endif

    mov eax,0
    ret
endp

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
section '.data' data readable writeable

  Title       db ' Menus',0
  ClassName   db ' AsmGges Win32',0
  MsgEnd      db ' AsmGges France @2006  ',0
  MsgBoxSM1_1 db 'Bonjour, mon Ami !',0
  MsgBoxSM1_2 db 'Au revoir, A bientt !',0
  MsgBoxSM1_3 db 'Fin de Programme !',0
  MsgBoxSM2_1 db 'Vous avez slectionn le sous-menu 2 !',0
  MsgBoxM3    db 'AsmGges France Win32asm Fasm Flat assembler',0
  align 4

  WinX        dd 0
  WinY        dd 0
  WinW        dd 512
  WinH        dd 352

  hWnd        dd ?
  hMenu       dd ?
  wc          WNDCLASS  0,WindowProc,0,0,NULL,NULL,NULL,COLOR_WINDOW+1,NULL,ClassName
  msg         MSG

;===========================================================================================
; Inclusion des fichiers .dll contenant les fonctions Windows utilises
;-------------------------------------------------------------------------------------------
section '.idata' import data readable writeable

  library kernel32,'KERNEL32.DLL',\
            user32,'USER32.DLL'

  ; Apis Windows dans fichiers dlls
  ; -------------------------------
  include 'apia\kernel32.inc'
  include 'apia\user32.inc'

;===========================================================================================
; Inclusion des icnes / curseurs / bitmap
;-------------------------------------------------------------------------------------------
section '.rsrc' resource data readable

  directory RT_MENU,menus,\
            RT_ICON,icons,\
            RT_GROUP_ICON,group_icons

  IDI_FRANCE = 17

  resource menus,\
           IDM_MENU,LANG_ENGLISH+SUBLANG_DEFAULT,main_menu

  resource icons,\
           1,LANG_NEUTRAL,icon_data

  resource group_icons,\
           IDI_FRANCE,LANG_NEUTRAL,main_icon

  IDM_MENU     = 37

  IDM_MENU1    = 100          ;menu 1
  IDM_BONJOUR  = 101          ;sub menu 1_1
  IDM_AUREVOIR = 102          ;sub menu 1_2
  IDM_QUITTER  = 103          ;sub menu 1_3

  IDM_MENU2    = 200          ;menu 2
  IDM_SMENU21  = 201          ;sub menu 2_1

  IDM_MENU3    = 300          ;menu 3

  menu main_menu
       menuitem '&Menu1',IDM_MENU1,MFR_POPUP
                menuitem '&Bonjour',IDM_BONJOUR
                menuitem '&Au revoir',IDM_AUREVOIR
                menuseparator
                menuitem '&Quitter',IDM_QUITTER,MFR_END

       menuitem 'M&enu2',IDM_MENU2,MFR_POPUP
                menuitem '&SousMenu2',IDM_SMENU21,MFR_END

       menuitem 'Me&nu3',IDM_MENU3,MFR_END

  icon main_icon,icon_data,'res\france.ico'

;===========================================================================================
